package com.jenny.compressedblocks.datagen;

import com.jenny.compressedblocks.CompressedBlocks;
import com.jenny.compressedblocks.modblocks.ModBlocks;
import net.minecraft.core.HolderLookup;
import net.minecraft.data.PackOutput;
import net.minecraft.tags.BlockTags;
import net.minecraftforge.common.data.BlockTagsProvider;
import net.minecraftforge.common.data.ExistingFileHelper;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.concurrent.CompletableFuture;

public class ModBlockTagGenerator extends BlockTagsProvider {
    public ModBlockTagGenerator(PackOutput output, CompletableFuture<HolderLookup.Provider> lookupProvider, @Nullable ExistingFileHelper existingFileHelper) {
        super(output, lookupProvider, CompressedBlocks.MODID, existingFileHelper);
    }

    @Override
    protected void addTags(@NotNull HolderLookup.Provider pProvider) {
        this.tag(BlockTags.MINEABLE_WITH_PICKAXE)
                .add(
                        ModBlocks.COBBLESTONE_1X.get(),
                        ModBlocks.COBBLESTONE_2X.get(),
                        ModBlocks.COBBLESTONE_3X.get(),
                        ModBlocks.COBBLESTONE_4X.get(),

                        ModBlocks.ANDESITE_1X.get(),
                        ModBlocks.ANDESITE_2X.get(),
                        ModBlocks.ANDESITE_3X.get(),
                        ModBlocks.ANDESITE_4X.get(),

                        ModBlocks.DIORITE_1X.get(),
                        ModBlocks.DIORITE_2X.get(),
                        ModBlocks.DIORITE_3X.get(),
                        ModBlocks.DIORITE_4X.get(),

                        ModBlocks.GRANITE_1X.get(),
                        ModBlocks.GRANITE_2X.get(),
                        ModBlocks.GRANITE_3X.get(),
                        ModBlocks.GRANITE_4X.get(),

                        ModBlocks.CBLOCK_MINING.get()
                );

        this.tag(BlockTags.NEEDS_STONE_TOOL)
                .add(
                        ModBlocks.COBBLESTONE_1X.get(),
                        ModBlocks.ANDESITE_1X.get(),
                        ModBlocks.DIORITE_1X.get(),
                        ModBlocks.GRANITE_1X.get()
                );

        this.tag(BlockTags.NEEDS_IRON_TOOL)
                .add(
                        ModBlocks.COBBLESTONE_2X.get(),
                        ModBlocks.ANDESITE_2X.get(),
                        ModBlocks.DIORITE_2X.get(),
                        ModBlocks.GRANITE_2X.get(),

                        ModBlocks.COBBLESTONE_3X.get(),
                        ModBlocks.ANDESITE_3X.get(),
                        ModBlocks.DIORITE_3X.get(),
                        ModBlocks.GRANITE_3X.get()
                );

        this.tag(BlockTags.NEEDS_DIAMOND_TOOL)
                .add(
                        ModBlocks.COBBLESTONE_4X.get(),
                        ModBlocks.ANDESITE_4X.get(),
                        ModBlocks.DIORITE_4X.get(),
                        ModBlocks.GRANITE_4X.get(),
                        ModBlocks.CBLOCK_MINING.get()
                );
    }
}